unit ReaderU;

interface

uses
  Classes, Graphics, SysUtils, Forms;

type
  TReader = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  end;

const
palette:array[0..15]of TColor=(
{      0,11010048,   43008,11053056,
     168,11010216,   43176,11053224,
 5505024,16515072, 5548032,16558080,
 5505192,16515240, 5548200,16558248);}
 $FFFFFF, $000000, $7F0000, $009300,
 $0000FF, $000000, $9C009C, $007FFF,
 $00FFFF, $00FF00, $939300, $FFFF00,
 $FF0000, $FF00FF, $7F7F7F, $D2D2D2);

implementation
uses Windows,Main;

{ TReader }

var Entered, ExitNow:boolean;

procedure TReader.Execute;
var f:system.text;s,s2,buf:string;
fg:byte;i:word;bp:longint;
fs:TFontStyles;

procedure FlushBuf;
begin
with MainForm.Log do
  begin
  SelStart:=bp;
  SelLength:=0;
  SelAttributes.Color:=palette[fg];
  SelAttributes.Style:=fs;
  SelText:=buf;
  inc(bp,length(buf));

  Buf:='';
  end;
end;

begin
Self.FreeOnTerminate:=True;
with MainForm do
  begin
  if Entered then
    begin
    ExitNow:=True;
    repeat
    until Entered=false;
    ExitNow:=False;
    end;
  Entered:=True;
  LockWindowUpdate(Log.Handle);
  bp:=0;log.Clear;Buf:='';
  assignfile(f,FileName.Text);
  reset(f);
  while not eof(f)do
    begin
    Application.ProcessMessages;
    if Application.Terminated or Self.Terminated or ExitNow then
      break;

    readln(f,s);
    if(fg<>1)or(fs<>[])then FlushBuf;
    fg:=1;fs:=[];
    {b:=true;
    for i:=1 to length(s) do
      if ord(s[i])<32 then
        b:=false;
    if b and(pos('*',s)=0)then
      begin
      Log.SelStart:=p;
      Log.SelLength:=0;
      Log.SelAttributes.Color:=palette[fg];
      Log.SelAttributes.Style:=fs;
      Log.SelText:=s+#13#10;
      inc(p,length(s)+2);
      continue;
      end;}
    i:=1;
    while i<=length(s)do
      begin
      case s[i] of
        #03:begin
            FlushBuf;
            inc(i);s2:='';
            while s[i] in ['0'..'9']do
              begin
              s2:=s2+s[i];
              inc(i);
              end;
            if s2='' then fg:=0 else
            fg:=strtoint(s2);
            if s[i]=',' then
              repeat inc(i) until not (s[i] in ['0'..'9']);
            end;
        #31:begin FlushBuf;if fsUnderline in fs then fs:=fs-[fsUnderline] else fs:=fs+[fsUnderline];inc(i);end;
         #2:begin FlushBuf;if fsBold      in fs then fs:=fs-[fsBold     ] else fs:=fs+[fsBold     ];inc(i);end;
        #15:begin FlushBuf;fg:=1;fs:=[];inc(i);end;
        else
          begin
          if(s[i]='*')and((i=12)or(i=1))then
            begin FlushBuf;fg:=3;end;
          Buf:=Buf+s[i];
          inc(i);
          end;
        end;
      end;
    Buf:=Buf+#13#10;
    end;
  closefile(f);
  FlushBuf;
  LockWindowUpdate(0);
  Entered:=False;
  end;
end;

end.
