unit ReaderU2;

interface

uses
  Classes, Graphics, SysUtils, Forms;

type
  TReader = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  end;

const
palette:array[0..15]of TColor=(
{      0,11010048,   43008,11053056,
     168,11010216,   43176,11053224,
 5505024,16515072, 5548032,16558080,
 5505192,16515240, 5548200,16558248);}
 $FFFFFF, $000000, $7F0000, $009300,
 $0000FF, $000000, $9C009C, $007FFF,
 $00FFFF, $00FF00, $939300, $FFFF00,
 $FF0000, $FF00FF, $7F7F7F, $D2D2D2);

procedure LoadHgl;

implementation
uses Windows,Main;

{ TReader }

var Entered, ExitNow:boolean;

type
  TAttr=record
    Fg,Bg:byte;
    B,I,U:boolean;
    end;

var
  HglNr:byte;
  Hgl:array[1..100]of string;

procedure LoadHgl;
var f:text;
begin
  HglNr:=0;
  AssignFile(f,ExtractFilePath(ParamStr(0))+'Hgl.txt');
  Reset(f);
  while not eof(f) do
    begin
    inc(HglNr);
    ReadLn(f,Hgl[HglNr]);
    if (Hgl[HglNr]='')or(Hgl[HglNr][1]=';') then dec(HglNr);
    end;
  Close(f);
end;

procedure TReader.Execute;
var
  f,o:system.text;s,s2:string;
  i,j:word;
  Attr,OldAttr:TAttr;
  Tag:boolean;

{
C:\v2000me2\Logs\#pokeliga.DalNet.RU.20021229.log
}

procedure DoAttrs;
begin
if Attr.Fg<>OldAttr.Fg then
  begin
  write(o,'\cf'+inttostr(Attr.Fg+1));
  {OldAttr.B:=False;
  OldAttr.I:=False;
  OldAttr.U:=False;{}
  Tag:=True;
  end;
if Attr.Bg<>OldAttr.Bg then
  begin
  write(o,'\highlight'+inttostr(Attr.Bg+1));
  {OldAttr.B:=False;
  OldAttr.I:=False;
  OldAttr.U:=False;{}
  Tag:=True;
  end;
if Attr.B<>OldAttr.B then
  if Attr.B then
    begin write(o,'\b');Tag:=True;end
  else
    begin write(o,'\b0');Tag:=True;end;
if Attr.I<>OldAttr.I then
  if Attr.I then
    begin write(o,'\i');Tag:=True;end
  else
    begin write(o,'\i0');Tag:=True;end;
if Attr.U<>OldAttr.U then
  if Attr.U then
    begin write(o,'\ul');Tag:=True;end
  else
    begin write(o,'\ulnone');Tag:=True;end;
OldAttr:=Attr;
end;

begin
  FreeOnTerminate:=True;
  if Entered then
    begin
    ExitNow:=True;
    repeat
      Sleep(0);
    until Entered=false;
    ExitNow:=False;
    end;
  Entered:=True;
  //MainForm.Log.Clear;
  MainForm.FileName.Enabled:=False;
  assignfile(f,MainForm.FileName.Text);reset(f);
  assignfile(o,'log.rtf');rewrite(o);
  writeln(o,'{\rtf1\ansi\ansicpg1251\deff0\deflang1049\deflangfe1041{\fonttbl{\f0\fswiss\fprq2\fcharset0 Arial;}{\f1\fswiss\fprq2\fcharset204{\*\fname Arial;}Arial CYR;}}');
  write(o,'{\colortbl ;');
  for i:=0 to 15 do
    begin
    write(o,'\red',inttostr(GetRValue(Palette[i])));
    write(o,'\green',inttostr(GetGValue(Palette[i])));
    write(o,'\blue',inttostr(GetBValue(Palette[i])),';');
    end;
  writeln(o,'}');
  write(o,'\lang1033\f1\fs20');Tag:=True;
  while not eof(f)do
    begin
    Application.ProcessMessages;
    if Application.Terminated or Self.Terminated or ExitNow then
      break;{}

    readln(f,s);

    i:=1;
    while i<=length(s) do
      begin
      for j:=1 to HglNr do
        if UpperCase(Hgl[j])=UpperCase(Copy(s,i,length(Hgl[j]))) then
          begin
          insert(#2,s,i+length(Hgl[j]));
          insert(#2,s,i);
          inc(i,length(Hgl[j]));
          end;
      inc(i);
      end;

    Attr.Fg:=1;
    Attr.Bg:=0;
    Attr.B:=False;
    Attr.I:=False;
    Attr.U:=False;
    //FlushBuf;
    i:=1;
    while i<=length(s)do
      begin
      case s[i] of
        #03:begin
            inc(i);s2:='';
            while s[i] in ['0'..'9']do
              begin
              s2:=s2+s[i];
              inc(i);
              end;
            if s2='' then Attr.Fg:=1 else
              Attr.Fg:=StrToInt(s2);
            if s[i]=',' then
              begin
              //repeat inc(i) until not (s[i] in ['0'..'9']);
              inc(i);s2:='';
              while s[i] in ['0'..'9']do
                begin
                s2:=s2+s[i];
                inc(i);
                end;
              if s2='' then Attr.Bg:=0 else
                Attr.Bg:=StrToInt(s2);
              end;
            //FlushBuf;
            if Attr.Fg=Attr.Bg then
              if Attr.Fg=0 then
                Attr.Fg:=1
              else
                Attr.Fg:=0;
            end;
        #31:begin Attr.U:=not Attr.U;{FlushBuf;}inc(i);end;
         #2:begin Attr.B:=not Attr.B;{FlushBuf;}inc(i);end;
        #15:begin
            Attr.Fg:=1;
            Attr.Bg:=0;
            Attr.B:=False;
            Attr.I:=False;
            Attr.U:=False;
            {FlushBuf;}
            inc(i);
            end;
        else
          begin
          if(i=1)or(copy(s,i-2,2)='] ') then
            begin
            if s[i]='*' then
              Attr.Fg:=3;
            if(s[i]='-')and(s[i+1]='>')then
              Attr.Fg:=4;
            end;
          DoAttrs;
          if Tag then
            begin write(o,' ');Tag:=False;end;
          if s[i] in ['{','}','\'] then
            write(o,'\');
          write(o,s[i]);
          inc(i);
          end;
        end;
      end;
    DoAttrs;
    writeln(o,'\par');Tag:=False;
    end;
  closefile(f);
  //FlushBuf;
  DoAttrs;
  writeln(o,'}');
  closefile(o);
  if Application.Terminated or Self.Terminated or ExitNow then
  else
    begin
    MainForm.Log.Clear;
    MainForm.Log.Lines.LoadFromFile('log.rtf');
    end;
  MainForm.FileName.Enabled:=True;
//  erase(o);
  Entered:=False;
end;

end.
